<?php
/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Class for creating dynamic graphics menu                             */
/*                                                                      */
/* Copyright (c) 2003 by S.Svinarenko, L.Krivelyov                      */
/* http://www.12thlevel.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

class CGraphMenu{

	/**
	 *  Private Variables
	 */
	var $_hover_file;
	var $_btn_file;
	var $_font_file;
	var $_font_size;
	var $_text_x;
	var $_text_y;
	var $_color_normal;
	var $_color_hover;
	var $_theme_sel;
	var $_quality;
	
	
    function CGraphMenu($theme_sel, $hover_file, $btn_file, $font_file, $font_size, $text_x, $text_y, $color_normal, $color_hover, $quality = -1){
		$this->_hover_file = $hover_file;
		$this->_btn_file = $btn_file;
		$this->_font_file = realpath($font_file);
		$this->_font_size = $font_size;
		$this->_text_x = $text_x;
		$this->_text_y = $text_y;
		$this->_color_normal = $color_normal;
		$this->_color_hover = $color_hover;
		$this->_theme_sel = $theme_sel;
		$this->_quality = $quality;
    }

    /**
     * CGraphMenu :: create_menu()
     * 
     * Public Method
     */
    function create_menu($m_id, $m_title, $language){
    	$hover_ext = substr($this->_hover_file, -4);
    	$btn_ext = substr($this->_btn_file, -4);
		$dir = "themes/$this->_theme_sel/images/menu_block/";
    	if ((!file_exists($dir.$language."_t_$m_id.txt")) || 
    			(!file_exists($dir.$language."_h_$m_id$hover_ext")) || 
    			(!file_exists($dir.$language."_b_$m_id$btn_ext"))){
        	if (!file_exists($this->_hover_file) || !file_exists($this->_btn_file) || $this->_hover_file == "" || $this->_btn_file == ""){
                echo "Warning CGraphMenu: Graphic files don't exist.";
    			return false;
    		}
    		$images[] = $this->_menu_text($m_title, $this->_btn_file, $dir.$language."_b_$m_id$btn_ext", $this->_color_normal);
    		$images[] = $this->_menu_text($m_title, $this->_hover_file, $dir.$language."_h_$m_id$hover_ext", $this->_color_hover);
    		if(!in_array(false, $images)){
        		$fd = fopen($dir.$language."_t_$m_id.txt", "w");
        		fwrite($fd, $m_title);
        		fclose ($fd);
    		}
    	}
    	else {
    		$fd = fopen($dir.$language."_t_$m_id.txt", "r+");
    		$old_title = fread ($fd, filesize ($dir.$language."_t_$m_id.txt"));
    		if ($m_title != $old_title){
        		$images[] = $this->_menu_text($m_title, $this->_btn_file, $dir.$language."_b_$m_id$btn_ext", $this->_color_normal);
        		$images[] = $this->_menu_text($m_title, $this->_hover_file, $dir.$language."_h_$m_id$hover_ext", $this->_color_hover);
    			if(!in_array(false, $images)){
        			ftruncate($fd, 0);
        			fwrite($fd, $m_title);
    			}			
    		}
    		else {
           		$images[] = $dir.$language."_b_$m_id$btn_ext";
           		$images[] = $dir.$language."_h_$m_id$hover_ext";
    		}
    		fclose ($fd);
    	}
    
    	if(!in_array(false, $images))
    		return $images;
    	else
    		return false;
    }

	/**
	 * CGraphMenu :: _encode()
	 * 
	 * Private Method
	 * Encodes ANSI characters to Unicode in Windows-1251 charset.
	 */
	function _encode($str){
        $out = "";
        for ($i=0; $i<strlen($str); $i++){
    		$asc = ord($str[$i]);
        	if($asc>=192){
        		$var = 1040+$asc-192;
        		$out .= "&#$var;";
        	}
        	elseif($asc == 168){
        		$var = 1025;
        		$out .= "&#$var;";
    		}
        	elseif($asc == 184){
        		$var = 1105;
        		$out .= "&#$var;";
    		}
        	elseif($asc == 191){
        		$var = 1111;
        		$out .= "&#$var;";
    		}
        	elseif($asc == 186){
        		$var = 1108;
        		$out .= "&#$var;";
    		}
        	elseif($asc ==179 ){
        		$var = 1110;
        		$out .= "&#$var;";
    		}
        	elseif($asc ==170 ){
        		$var = 1028;
        		$out .= "&#$var;";
    		}
        	elseif($asc ==178 ){
        		$var = 1030;
        		$out .= "&#$var;";
    		}
        	elseif($asc ==175 ){
        		$var = 1031;
        		$out .= "&#$var;";
    		}
    		else		
        		$out .= $str[$i];
        }
    	return $out;
	}

    /**
     * CGraphMenu :: menu_text()
     * 
     * Private Method
     */
    function _menu_text($str, $image, $file_name, $textcolor){
       	if (!file_exists($image) || $image == "")
    		return false;
    	$im_info = getimagesize($image);
    	$color_red = ($textcolor & 0xFF0000) >> 16;
        $color_green = ($textcolor & 0xFF00) >> 8;
        $color_blue = $textcolor & 0xFF;
        
    	switch($im_info['2']) {
    		case 1:						//gif
    			if(function_exists("imagecreatefromgif")) {
    				$im = imagecreatefromgif($image);
    				if($str!=""){
    			    	if (!file_exists($this->_font_file) || $this->_font_file == "")
        					return false;
						$color = imagecolorallocate ($im, $color_red, $color_green, $color_blue);
						if ($color == -1)
	        				$color = imagecolorclosest ($im, $color_red, $color_green, $color_blue);
        				imagettftext($im, $this->_font_size, 0, $this->_text_x, $this->_text_y, $color, $this->_font_file, $this->_encode($str));
    				}
    				imagegif($im, $file_name);
    				imagedestroy($im);
    			}
    			else
    				return false;
    		break;
    		case 2:						//jpeg
    			if(function_exists("imagecreatefromjpeg")){
    				$im = imagecreatefromjpeg($image);
    				if($str!=""){
    			    	if (!file_exists($this->_font_file) || $this->_font_file == "")
                        {
                            echo "Warning CGraphMenu: Font file doesn't exist.";
        					return false;
                        }
						$color = imagecolorallocate ($im, $color_red, $color_green, $color_blue);
						if ($color == -1)
	        				$color = imagecolorclosest ($im, $color_red, $color_green, $color_blue);
        				imagettftext($im, $this->_font_size, 0, $this->_text_x, $this->_text_y, $color, $this->_font_file, $this->_encode($str));
//						error_log("image: $image;\t\tcolor: $color\t\tred: $color_red;\t\tgreen: $color_green;\t\tblue: $color_blue\n", 3, "errors.log");
    				}
					if ($this->_quality >=0)
    					imagejpeg($im, $file_name, $this->_quality);
					else
						imagejpeg($im, $file_name);
    				imagedestroy($im);
    			}
    			else
    				return false;
    		break;
    		case 3:						//png
    			if(function_exists("imagecreatefrompng")){
    				$im = imagecreatefrompng($image);
    				if($str!=""){
    			    	if (!file_exists($this->_font_file) || $this->_font_file == "")
        					return false;
						$color = imagecolorallocate ($im, $color_red, $color_green, $color_blue);
						if ($color == -1)
	        				$color = imagecolorclosest ($im, $color_red, $color_green, $color_blue);
        				imagettftext($im, $this->_font_size, 0, $this->_text_x, $this->_text_y, $color, $this->_font_file, $this->_encode($str));
    				}
    				imagepng($im, $file_name);
    				imagedestroy($im);
    			}
    			else
    				return false;
    		break;
    		default:
    			return false;
    	}
    	return $file_name;
    }
	
}
?>